



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Redis到底该如何利用？</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Redis到底该如何利用？</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-25 03:13:41 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><!--<br />
.hf-h2{ background: #2B6695 !important; border-radius: 6px 6px 6px 6px !important; box-shadow: 0 0 0 1px #5F5A4B, 1px 1px 6px 1px rgba(10, 10, 0, 0.5); color: #FFFFFF; font-family: "微软雅黑" , "宋体" , "黑体" ,Arial; font-size: 17px; font-weight: bold; height: 25px; line-height: 25px; margin: 15px 0 !important; padding: 5px 0 5px 20px; text-shadow: 2px 2px 3px #222222; } .hf-line{ text-indent: 2em!important; } div.post div.entry ul li{ list-style: none!important; } .bs-callout{ border-left-color: #5bc0de; box-sizing: border-box; font-family: "Helvetica Neue", Helvetica, Microsoft Yahei, Hiragino Sans GB, WenQuanYi Micro Hei, sans-serif; font-size: 14px; line-height: 1.42857143; color: #333; background-color: #fff; padding: 20px; margin: 20px 0; border: 1px solid #eee; border-left-width: 5px; border-radius: 3px; } .bs-callout-warn{ border-left-color:#f0ad4e; } .bs-callout-danger { border-left-color: #d9534f; } .bs-callout-info { border-left-color: #5bc0de; } #cnblogs_post_body ul li{ list-style: none!important; }<br />
--></p>
<p>Redis是个好东西，经过上两个星期的研究和实践，目前正在项目里大规模的替换掉原来的本地内存cache。但是替换过程中却发现，Redis这东西高端，大气上档次，似乎不是我想象里的使用方法。</p>
<p>在没有深入Redis之前，在我的概念里，缓存，就是key-value。而使用方式肯定不需要改动多少代码，一切都是Get/Set。但是实际用的时候却发现，我错了，不是所有的场景都是简单的Get/Set。也不是所有的数据都适合key-Value，于是有了这个问题，Redis到底该如何使用？我问自己，也向园子里的朋友们求助，希望帮忙解答。当然，这篇文章抛砖引玉，先谈谈我这两周的感悟。</p>
<h2>使用场景</h2>
<p>在我的项目里，有一个提供给<code>Autocomplete的功能，数据量大概在几万。这篇文章里我用姓名检索的例子来说明，列表请戳来自<a href="http://antirez.com/misc/female-names.txt" rel="external nofollow noreferrer">Redis作者的Demo</a>。</code></p>
<p>在这样的列表里全是用户名，例如我们的系统里有一个用户对象：</p>
<div>
<pre class="prettyprint linenums">public Class User<br />
{<br />
     public string Id{get; set;}<br />
     public string Name {get; set;}<br />
     ....<br />
     public string UserHead {get; set;}<br />
}</pre>
</div>
<p>系统里需要一个用户的下拉列表，由于数据量大不能一次显示完，于是就加上了一个AutoComplete功能。如果是不用Redis这样的集中式缓存，直接缓存在本机内存里，那么结构很简单如下：</p>
<div>
<pre class="prettyprint linenums">var users = new List&lt;User&gt;{...};//读到一个用户列表<br />
MemoryCache.Set("capqueen:users", users);//放入内存

//读取<br />
var users = MemoryCache.Get&lt;List&lt;User&gt;&gt;("capqueen:users");</pre>
</div>
<p>因为都是在内存里，所以直接存List就可以了，搜索的时候也可以直接的如下：</p>
<div>
<pre class="prettyprint linenums">var findUsers = users.Where(user =&gt; user.Name.StartWith("A")).ToList();例如输入的字符是 &ldquo;A&ldquo;</pre>
</div>
<p>相当简单，完全不用考虑如何存储，存储的数据结构。但是换到了Redis这些集中式缓存服务之后，咱们再来思考，该如何存储。</p>
<p>方案一：类似内存式的缓存实现。</p>
<div>
<p>本文里使用的Redis链接库是<a href="https://github.com/StackExchange/StackExchange.Redis" rel="external nofollow noreferrer">StactkExchange.Redis</a>，出自StackOverFlow的开源产品。</p>
</div>
<div>
<pre class="prettyprint linenums">var db = redis.GetDataBase();//获取0数据库

var usersJson = JsonConvert.SerializeObject(users)//序列化

db.StringSet("capqueen:users", usersJson);//存储

var usersString = db.StringGet("capqueen:users");<br />
var userList = JsonConvert.DeserializeObject&lt;List&lt;User&gt;&gt;(users);//反序列化</pre>
</div>
<p>上面的方式逻辑上是没有问题的，编译也可以通过。但是仔细想一想，Redis作为独立的缓存服务和appSever是分开来的，这样的读取方式对redis服务器的IO是个负担，甚至这样的读取比本地内存缓存慢了太多了。</p>
<p>那如何解决呢？试想key-value的精髓是在于Key，那么对于List来说应该要把item分开来存储。</p>
<p>方案二：Keys模糊匹配。</p>
<p>在查看了Redis的命令文档（见参考资料4）之后，发现了命令Keys，如获至宝，立马修改了方案。首先我们需要把要搜索的关键词建立为key，这里我把key定义为 "capqueen:user:{id}:{name}"，其中{}内的是要用item对应属性替换的。代码如下：</p>
<div>
<pre class="prettyprint linenums">var redis = ConnectionMultiplexer.Connect("localhost");<br />
var db = redis.GetDatabase();

var users = new List&lt;User&gt; {<br />
    new User{Id = , Name = "aaren", Age=},<br />
    new User{Id = , Name = "issy", Age=},<br />
    new User{Id = , Name = "janina", Age=},<br />
    new User{Id = , Name = "karena", Age=}<br />
};

users.ForEach(item =&gt; {<br />
   var key = string.Format("capqueen:user:{0}:{1}", item.Id, item.Name);<br />
   var value = JsonConvert.SerializeObject(item);<br />
   db.StringSet(key, value);<br />
});</pre>
</div>
<p>建立好的缓存如下图所示：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/452359/201411/171332447547188.png" /></p>
<p>所有的user都以单独的Key-Value方式存储，那么如何利用Keys搜索呢？我们来看下Redis的Keys命令：</p>
<div>
<pre class="prettyprint linenums">KEYS pattern

查找所有符合给定模式 pattern 的 key 。

KEYS * 匹配数据库中所有 key 。<br />
KEYS h?llo 匹配 hello ， hallo 和 hxllo 等。<br />
KEYS h*llo 匹配 hllo 和 heeeeello 等。<br />
KEYS h[ae]llo 匹配 hello 和 hallo ，但不匹配 hillo 。<br />
特殊符号用 \ 隔开</pre>
</div>
<p>也就是说Keys能够进行简单的模糊匹配，那么我们这里的搜索就可以换成如下的方式:</p>
<div>
<pre class="prettyprint linenums">var redis = ConnectionMultiplexer.Connect("192.168.10.178");<br />
var db = redis.GetDatabase();<br />
var server = redis.GetServer("192.168.10.178", );<br />
var keys = server.Keys(pattern: "capqueen:user:*:a*");<br />
var values = db.StringGet(keys.ToArray());

//反序列化<br />
var jsonValues = new StringBuilder("[");<br />
values.ToList().ForEach(item =&gt; jsonValues.Append(item).Append(","));<br />
jsonValues.Append("]");<br />
var userList = JsonConvert.DeserializeObject&lt;List&lt;User&gt;&gt;(jsonValues.ToString());</pre>
</div>
<p>注意以上的代码里，因为每个value是一个json，为了增加转化时的效率，我先处理成json arry再进行反序列化。</p>
<p>这种方案，确实是解决了我目前的问题，然而我注意到了Redis文档里的一段话：</p>
<div>
<p><a href="http://redisdoc.com/key/keys.html#keys" rel="external nofollow noreferrer">KEYS</a>&nbsp;的速度非常快，但在一个大的数据库中使用它仍然可能造成性能问题，如果你需要从一个数据集中查找特定的&nbsp;<code>key</code>&nbsp;，你最好还是用 Redis 的集合结构(set)来代替。</p>
</div>
<div>
<p>这段话换而言之就是慎用Keys搜索的意思，那么有什么更好的解决方案呢？由于这篇文章我拖得很久了，这里留个问题在末尾，期待有大牛能够帮忙解答，感激不尽。当然还有下一篇内容，我会讲讲我目前的处理方法。</p>
<p>下篇文章里，我会根据Redis作者的博客（资料1）里的做法以及我最后查到的资料，做一个新的方案，请大家到时指教。</p>
</div>
<h2>参考资料</h2>
<ol><li>Redis作者博客，这是其中一篇讲如何基于Redis实现AutoComplete的文章：<a href="http://oldblog.antirez.com/post/redis-weekly-update-7.html" rel="external nofollow noreferrer">http://oldblog.antirez.com/post/autocomplete-with-redis.html</a></li>
<li>Redis 第三方管理工具 For Windows:<a href="http://redisdesktop.com/" rel="external nofollow noreferrer">http://redisdesktop.com/</a></li>
<li>Redis .NET链接工具的Top20：<a href="http://nugetmusthaves.com/Tag/Redis" rel="external nofollow noreferrer">http://nugetmusthaves.com/Tag/Redis</a></li>
<li>Redis命令中文文档：<a href="http://redisdoc.com/" rel="external nofollow noreferrer">http://redisdoc.com/</a></li></ol>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxlgyzq.html">include、merge 、ViewStub</a>
		</li>
						<li><a href="https://www.batexi.com/a/390ed1oq.html">POJ Challenge消失之物</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnx3029.html">ServiceStack&period;Redis之IRedisClient&amp;lt&semi;第三篇&amp;gt&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd7kld8.html">最长回文子串&lpar;Longest Palindromic Substring&rpar;-DP问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vk3vm8.html">BNUOJ-26580 Software Bugs KMP匹配&comma;维护</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn4gzv8.html">Github上关于大数据的开源项目、论文等合集</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0onw0q.html">夏梦竹谈Hive vs&period; HBase的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde7mj79.html">CentOS6&period;5 --安装orale 11g&lpar;上&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jkmjo8.html">Egret  显示容器</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pzrej8.html">enote笔记法（2）&mdash;&mdash;why的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zw6kj9.html">python装饰器实现对异常代码出现进行监控</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkxmwe8.html">shell参数传递</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4yrom9.html">Java框架spring 学习笔记（六）：属性注入</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o7enj8.html">Linux 典型应用之远程连接SSH</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjm4069.html">集成Javascript Logging on MVC or Core</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25mmwoq.html">windows server 2008 远程连接</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r57xpmq.html">解决apache httpd列出目录列表中文乱码问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj05l49.html">Prezento &ndash; 轻量、简单的 jQuery 幻灯片插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjxlg39.html">Solr&mdash;&mdash;从postgresql数据库导入数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmmz049.html">H3C交换机配置的备份与恢复&lpar;TFTP方法）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/39rnoorq.html">数据结构图文解析之：AVL树详解及C&plus;&plus;模板实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mjgoo8.html">nginx 反向代理</a>
			</li>
						<li><a href="https://www.batexi.com/a/49535kz8.html">python函数 与 函数式编程</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8km0639.html">如何实现CDN的ns智能解析和动手验证Akamai的实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mdnno8.html">&amp;lt&semi;&amp;lt&semi;&amp;lt&semi; sqlserver、Mysql、Oracle数据库优缺点</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq44zzjq.html">初学Java 精简知识点总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93jyvr8.html">nltk27&lowbar;NLTK聚类分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q77zdkq.html">在github上搭建hexo博客</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvd1mxq.html">flask-whooshalchemy需要注意的一点</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8od1m5q.html">浅谈Android中的startActivityForResult和setResult方法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
